#!/bin/zsh

odt_manifest(){
  cat <<-EOF
	<?xml version="1.0" encoding="UTF-8"?>
	<manifest:manifest xmlns:manifest="urn:oasis:names:tc:opendocument:xmlns:manifest:1.0" manifest:version="1.2">
	  <manifest:file-entry manifest:full-path="/" manifest:version="1.2" manifest:media-type="application/vnd.oasis.opendocument.text"/>
	  <manifest:file-entry manifest:full-path="styles.xml" manifest:media-type="text/xml"/>
	  <manifest:file-entry manifest:full-path="content.xml" manifest:media-type="text/xml"/>
	</manifest:manifest>
	EOF
}

odt_stylesheet(){
  local iban="$1" bic="$2"

  cat <<-EOF
	<?xml version="1.0" encoding="UTF-8"?>
	<office:document-styles xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0" xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" xmlns:table="urn:oasis:names:tc:opendocument:xmlns:table:1.0" xmlns:fo="urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:meta="urn:oasis:names:tc:opendocument:xmlns:meta:1.0" xmlns:number="urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0" xmlns:ooo="http://openoffice.org/2004/office" xmlns:ooow="http://openoffice.org/2004/writer" xmlns:oooc="http://openoffice.org/2004/calc" xmlns:dom="http://www.w3.org/2001/xml-events" xmlns:rpt="http://openoffice.org/2005/report" xmlns:of="urn:oasis:names:tc:opendocument:xmlns:of:1.2" xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns:grddl="http://www.w3.org/2003/g/data-view#" xmlns:officeooo="http://openoffice.org/2009/office" xmlns:tableooo="http://openoffice.org/2009/table" xmlns:loext="urn:org:documentfoundation:names:experimental:office:xmlns:loext:1.0" xmlns:css3t="http://www.w3.org/TR/css3-text/" office:version="1.2">
	  <office:styles>
	    <style:style style:name="Standard" style:family="paragraph" style:class="text">
	      <style:paragraph-properties fo:text-align="start" style:justify-single-word="false"/>
	      <style:text-properties style:font-name="DejaVu Sans" fo:font-family="'DejaVu Sans'" style:font-family-generic="swiss" style:font-pitch="variable" style:font-size-asian="10.5pt" style:font-weight-asian="normal"/>
	    </style:style>
	  </office:styles>
	  <office:automatic-styles>
	    <style:style style:name="MP1" style:family="paragraph">
	      <style:paragraph-properties fo:text-align="center" style:justify-single-word="false"/>
	      <style:text-properties style:font-name="DejaVu Sans" fo:font-size="10.5pt" style:font-size-asian="10.5pt" style:font-size-complex="10.5pt"/>
	    </style:style>
	    <style:style style:name="MT1" style:family="text">
	      <style:text-properties fo:font-weight="bold" style:font-weight-asian="bold" style:font-weight-complex="bold"/>
	    </style:style>
	    <style:page-layout style:name="Mpm1">
	      <style:page-layout-properties fo:page-width="8.2681in" fo:page-height="11.6929in" style:num-format="1" style:print-orientation="portrait" fo:margin-top="0.7874in" fo:margin-bottom="0.7874in" fo:margin-left="0.7874in" fo:margin-right="0.7874in" style:writing-mode="lr-tb" style:footnote-max-height="0in">
	        <style:footnote-sep style:width="0.0071in" style:distance-before-sep="0.0398in" style:distance-after-sep="0.0398in" style:line-style="solid" style:adjustment="left" style:rel-width="25%" style:color="#000000"/>
	      </style:page-layout-properties>
	      <style:header-style/>
	      <style:footer-style>
	        <style:header-footer-properties fo:min-height="0in" fo:margin-left="0in" fo:margin-right="0in" fo:margin-top="0.1965in"/>
	      </style:footer-style>
	    </style:page-layout>
	  </office:automatic-styles>
	  <office:master-styles>
	    <style:master-page style:name="Standard" style:page-layout-name="Mpm1">
	      <style:footer>
	        <text:p text:style-name="MP1">
	          <text:span text:style-name="MT1">Bankverbindung - IBAN:</text:span>
	          <text:span>${iban}</text:span>
	          <text:span text:style-name="MT1">| BIC:</text:span>
	          <text:span>${bic}</text:span>
	        </text:p>
	      </style:footer>
	    </style:master-page>
	  </office:master-styles>
	</office:document-styles>
	EOF
}

odt_content(){
  local id="$1" sender="$2" client="$3" date="$4" number="$5" vat="$6" vatrate="$7" hourly="$8" \
        taxtype nett tax gross
  read -r taxtype nett tax gross <<-EOF
	$(invoice_total "$id")
	EOF

  cat <<-EOF
	<?xml version="1.0" encoding="UTF-8"?>
	<office:document-content xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0" xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" xmlns:table="urn:oasis:names:tc:opendocument:xmlns:table:1.0" xmlns:draw="urn:oasis:names:tc:opendocument:xmlns:drawing:1.0" xmlns:fo="urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:meta="urn:oasis:names:tc:opendocument:xmlns:meta:1.0" xmlns:number="urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0" xmlns:svg="urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0" xmlns:chart="urn:oasis:names:tc:opendocument:xmlns:chart:1.0" xmlns:dr3d="urn:oasis:names:tc:opendocument:xmlns:dr3d:1.0" xmlns:math="http://www.w3.org/1998/Math/MathML" xmlns:form="urn:oasis:names:tc:opendocument:xmlns:form:1.0" xmlns:script="urn:oasis:names:tc:opendocument:xmlns:script:1.0" xmlns:ooo="http://openoffice.org/2004/office" xmlns:ooow="http://openoffice.org/2004/writer" xmlns:oooc="http://openoffice.org/2004/calc" xmlns:dom="http://www.w3.org/2001/xml-events" xmlns:xforms="http://www.w3.org/2002/xforms" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:rpt="http://openoffice.org/2005/report" xmlns:of="urn:oasis:names:tc:opendocument:xmlns:of:1.2" xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns:grddl="http://www.w3.org/2003/g/data-view#" xmlns:officeooo="http://openoffice.org/2009/office" xmlns:tableooo="http://openoffice.org/2009/table" xmlns:drawooo="http://openoffice.org/2010/draw" xmlns:calcext="urn:org:documentfoundation:names:experimental:calc:xmlns:calcext:1.0" xmlns:loext="urn:org:documentfoundation:names:experimental:office:xmlns:loext:1.0" xmlns:field="urn:openoffice:names:experimental:ooo-ms-interop:xmlns:field:1.0" xmlns:formx="urn:openoffice:names:experimental:ooxml-odf-interop:xmlns:form:1.0" xmlns:css3t="http://www.w3.org/TR/css3-text/" office:version="1.2">
	  <office:automatic-styles>
	    <style:style style:name="Table1" style:family="table">
	      <style:table-properties style:width="6.7in" fo:margin-top="0in" fo:margin-bottom="0in" table:align="margins"/>
	    </style:style>
	    <style:style style:name="Table1.A" style:family="table-column">
	      <style:table-column-properties style:column-width="1.1in" style:rel-column-width="11000*"/>
	    </style:style>
	    <style:style style:name="Table1.B" style:family="table-column">
	      <style:table-column-properties style:column-width="3.4in" style:rel-column-width="34000*"/>
	    </style:style>
	    <style:style style:name="Table1.CD" style:family="table-column">
	      <style:table-column-properties style:column-width="1.1in" style:rel-column-width="11000*"/>
	    </style:style>
	    <style:style style:name="Table1.1" style:family="table-cell">
	      <style:table-cell-properties fo:padding="0.0201in" fo:border-left="none" fo:border-right="none" fo:border-top="none" fo:border-bottom="0.05pt solid #000000"/>
	    </style:style>
	    <style:style style:name="Table1.2" style:family="table-cell">
	      <style:table-cell-properties fo:padding="0.0201in" fo:border="none"/>
	    </style:style>
	    <style:style style:name="Table1.6" style:family="table-cell">
	      <style:table-cell-properties fo:padding="0.0201in" fo:border-left="none" fo:border-right="none" fo:border-top="0.05pt solid #000000" fo:border-bottom="none"/>
	    </style:style>
	    <style:style style:name="P3" style:family="paragraph" style:parent-style-name="Standard">
	      <style:text-properties style:font-name="DejaVu Sans" fo:font-size="10.5pt" style:font-size-asian="10.5pt" style:font-size-complex="10.5pt"/>
	    </style:style>
	    <style:style style:name="P5" style:family="paragraph" style:parent-style-name="Standard">
	      <style:paragraph-properties fo:text-align="end" style:justify-single-word="false"/>
	      <style:text-properties fo:font-size="10.5pt" style:font-size-asian="10.5pt" style:font-size-complex="10.5pt"/>
	    </style:style>
	    <style:style style:name="P6" style:family="paragraph" style:parent-style-name="Standard">
	      <style:paragraph-properties fo:text-align="start" style:justify-single-word="false"/>
	      <style:text-properties fo:font-weight="bold" fo:font-size="10.5pt" style:font-size-complex="10.5pt"/>
	    </style:style>
	    <style:style style:name="P7" style:family="paragraph" style:parent-style-name="Standard">
	      <style:paragraph-properties fo:text-align="end" style:justify-single-word="false"/>
	      <style:text-properties fo:font-weight="bold" fo:font-size="10.5pt" style:font-size-complex="10.5pt"/>
	    </style:style>
	    <style:style style:name="T3" style:family="text">
	      <style:text-properties fo:font-weight="bold" style:font-weight-asian="bold" style:font-weight-complex="bold"/>
	    </style:style>
	    <style:style style:name="fr1" style:family="graphic" style:parent-style-name="Standard">
	      <style:graphic-properties fo:margin-left="0in" fo:margin-right="0in" fo:margin-top="0in" fo:margin-bottom="0in" style:wrap="none" style:vertical-pos="from-top" style:vertical-rel="page-content" style:horizontal-pos="right" style:horizontal-rel="page-content" fo:padding="0in" fo:border="none" style:shadow="none" draw:shadow-opacity="100%"/>
	    </style:style>
	    <style:style style:name="fr2" style:family="graphic" style:parent-style-name="Standard">
	      <style:graphic-properties fo:margin-left="0in" fo:margin-right="0in" fo:margin-top="0in" fo:margin-bottom="0in" style:wrap="none" style:vertical-pos="top" style:vertical-rel="page-content" style:horizontal-pos="right" style:horizontal-rel="page-content" fo:padding="0in" fo:border="none" style:shadow="none" draw:shadow-opacity="100%"/>
	    </style:style>
	    <style:style style:name="fr3" style:family="graphic" style:parent-style-name="Standard">
	      <style:graphic-properties fo:margin-left="0in" fo:margin-right="0in" fo:margin-top="0in" fo:margin-bottom="0in" style:wrap="none" style:vertical-pos="from-top" style:vertical-rel="page-content" style:horizontal-pos="left" style:horizontal-rel="page-content" fo:padding="0in" fo:border="none" style:shadow="none" draw:shadow-opacity="100%"/>
	    </style:style>
	  </office:automatic-styles>
	  <office:body>
	    <office:text>
	      <text:p text:style-name="P3">
	        <draw:frame draw:style-name="fr1" draw:name="Rahmen4" text:anchor-type="paragraph" svg:y="2.7598in" svg:width="1.7283in">
	          <draw:text-box fo:min-height="0.2528in">
	            <text:p text:style-name="P5">$(date -d @${date} +%d.%m.%Y)</text:p>
	          </draw:text-box>
	        </draw:frame><draw:frame draw:style-name="fr2" draw:name="Rahmen2" text:anchor-type="paragraph" svg:width="1.8228in">
	          <draw:text-box fo:min-height="1.8992in">
	            <text:p text:style-name="P5"><!--
                 -->$(HTML "$sender" |sed -r 's;(&#13\;)?&#10\;;<text:line-break/>;g')<!--
	         --></text:p>
	          </draw:text-box>
	        </draw:frame><draw:frame draw:style-name="fr3" draw:name="Rahmen1" text:anchor-type="paragraph" svg:y="1.3799in" svg:width="3.4398in">
	          <draw:text-box fo:min-height="1.3311in">
	            <text:p text:style-name="P3"><!--
                   -->$(HTML "$client" |sed -r 's;(&#13\;)?&#10\;;<text:line-break/>;g')<!--
	           --></text:p>
	          </draw:text-box>
	        </draw:frame><text:span text:style-name="T3">Rechnung ${number}</text:span>
	      </text:p>
	      <text:p text:style-name="P3"/>
	      <text:p text:style-name="P3"/>
	      <text:p text:style-name="P3">Vergütung: ${hourly} € / Std.<!--
             -->$(case $vat in
                  (smallbusiness)
                    printf '<text:line-break/>Gemäß Kleinunternehmerregelung (§19 Umsatzsteuergesetz) wird keine Umsatzsteuer berechnet.';;
                  (nett)  printf 'zuzüglich %i%% MwSt.' "$vatrate";;
                  (gross) printf '(einschließlich %i%% MwSt.)' "$vatrate";;
                 esac)<!--
           --></text:p>
	      <text:p text:style-name="P3"/>
	      <table:table table:name="Table1" table:style-name="Table1">
	        <table:table-column table:style-name="Table1.A"/>
	        <table:table-column table:style-name="Table1.B"/>
	        <table:table-column table:style-name="Table1.CD"/>
	        <table:table-column table:style-name="Table1.CD"/>
	        <table:table-header-rows>
	          <table:table-row>
	            <table:table-cell table:style-name="Table1.1" office:value-type="string">
	              <text:p text:style-name="P6">Datum</text:p>
	            </table:table-cell>
	            <table:table-cell table:style-name="Table1.1" office:value-type="string">
	              <text:p text:style-name="P6">Art der Leistung</text:p>
	            </table:table-cell>
	            <table:table-cell table:style-name="Table1.1" office:value-type="string">
	              <text:p text:style-name="P7">Stundenzahl</text:p>
	            </table:table-cell>
	            <table:table-cell table:style-name="Table1.1" office:value-type="string">
	              <text:p text:style-name="P7">Betrag</text:p>
	            </table:table-cell>
	          </table:table-row>
	        </table:table-header-rows>
		$(sed 1d "invoices/$id" |while read -r time work hours; do
                   time="$(UNSTRING "${time#time=}")"
                   work="$(UNSTRING "${work#work=}")"
                  hours="$(UNSTRING "${hours#hours=}")"
		  cat <<-TROW
			<table:table-row>
			  <table:table-cell table:style-name="Table1.2" office:value-type="string">
			    <text:p text:style-name="P3">${time}</text:p>
			  </table:table-cell>
			  <table:table-cell table:style-name="Table1.2" office:value-type="string">
			    <text:p text:style-name="P3">${work}</text:p>
			  </table:table-cell>
			  <table:table-cell table:style-name="Table1.2" office:value-type="string">
			    <text:p text:style-name="P5">${hours}</text:p>
			  </table:table-cell>
			  <table:table-cell table:style-name="Table1.2" office:value-type="string">
			    <text:p text:style-name="P5">$((${hourly} * ${hours})) €</text:p>
			  </table:table-cell>
			</table:table-row>
			TROW
		done)
	        <table:table-row>
	          <table:table-cell table:style-name="Table1.6" office:value-type="string">
	            <text:p text:style-name="P6"/>
	          </table:table-cell>
                  $(case $taxtype in
                    (nett) cat <<-TCELL
			<table:table-cell table:style-name="Table1.6" table:number-columns-spanned="2" office:value-type="string">
			  <text:p text:style-name="P5">
			  Zwischensumme:<text:line-break/>
			  zzgl. ${vatrate}% MwSt.:<text:line-break/>
			  </text:p>
			  <text:p text:style-name="P7">zu zahlender Betrag:</text:p>
			</table:table-cell>
			<table:table-cell table:style-name="Table1.6" office:value-type="string">
			  <text:p text:style-name="P5">
			  ${nett} €<text:line-break/>
			  ${tax} €<text:line-break/>
			  </text:p>
			  <text:p text:style-name="P7">${gross} €</text:p>
			</table:table-cell>
			TCELL
                        ;;
                    (gross) cat <<-TCELL
			<table:table-cell table:style-name="Table1.6" table:number-columns-spanned="2" office:value-type="string">
			  <text:p text:style-name="P7">zu zahlender Betrag:</text:p>
			  <text:p text:style-name="P5">
			  <text:line-break/>
			  enthaltene MwSt (${vatrate}%):<text:line-break/>
			  enthaltener Netto-Betrag:<!--
			--></text:p>
			</table:table-cell>
			<table:table-cell table:style-name="Table1.6" office:value-type="string">
			  <text:p text:style-name="P7">${gross} €</text:p>
			  <text:p text:style-name="P5">
			  <text:line-break/>
			  ${tax} €<text:line-break/>
			  ${nett} €<!--
			--></text:p>
			</table:table-cell>
			TCELL
                        ;;
                    (*) cat <<-TCELL
			<table:table-cell table:style-name="Table1.6" table:number-columns-spanned="2" office:value-type="string">
			  <text:p text:style-name="P7">zu zahlender Betrag:</text:p>
			</table:table-cell>
			<table:table-cell table:style-name="Table1.6" office:value-type="string">
			  <text:p text:style-name="P7">${gross} €</text:p>
			</table:table-cell>
			TCELL
                        ;;
                  esac)
	        </table:table-row>
	      </table:table>
	    </office:text>
	  </office:body>
	</office:document-content>
	EOF
}

genodt(){
  local id="$1" exdir="export/$1"
  [ -d "$exdir" ] && {
    rm "$exdir/content.xml" "$exdir/styles.xml" "$exdir/META-INF/manifest.xml"
    rmdir "$exdir/META-INF/" "$exdir/"
  }

  read -r sender client date number vat vatrate hourly x<<-EOF
	$(sed q "invoices/$id")
	EOF
  read -r sender iban bic x<"senders/${sender#sender=}"
  read -r client chourly x<"clients/${client#client=}"

  mkdir -p "$exdir/META-INF"
  odt_manifest >"$exdir/META-INF/manifest.xml"
  odt_stylesheet "$(UNSTRING "${iban#iban=}")" "$(UNSTRING "${bic#bic=}")" >"$exdir/styles.xml"
  odt_content "$id" \
    "$(UNSTRING "${sender#address=}")" \
    "$(UNSTRING "${client#address=}")" \
    "${date#date=}" \
    "$(UNSTRING "${number#number=}")" \
    "${vat#vat=}" "${vatrate#vatrate=}" \
    "${hourly#hourly=}" \
  >"$exdir/content.xml"

  [ -f "export/${id}.odt" ] && rm "export/${id}.odt"
  ( cd "$exdir"
    zip -q "../${id}.odt" content.xml styles.xml META-INF/manifest.xml
  )
  rm "$exdir/content.xml" "$exdir/styles.xml" "$exdir/META-INF/manifest.xml"
  rmdir "$exdir/META-INF/" "$exdir/"
}

genpdf(){
  local id="$1"
  genodt "$id"
  lowriter --convert-to pdf --outdir "export/" "export/${id}.odt" >/dev/null
  rm "export/${id}.odt"
}

